#!/usr/local/bin/perl -w

print ("test 1\n");

$_= "barbarbarfoobarfoobarfoo";

if (/\w*foo/) {
    print ($&, "\n");
}
# matches barbarbarfoobarfoobarfoo

print ("test 2\n");

$_ = "barbarbar!foobarfoobarfoo";

if (/\w*foo/) {
    print ($&, "\n");
}
# matches foobarfoobarfoo

print ("test 3\n");

$_ = "a xxx c xxxxx c xxx d";

if (/a(.*)c.*d/) {
    print ($&, "\n");
    print ("\"$1\"", "\n");
}
# first .* matches " xxx c xxxxx " 
# (quotes only used to indicate spaces clearly)

print ("test 4 (lazy) \n");

$_= "barbarbarfoobarfoobarfoo";

if (/\w*?foo/) {
    print ($&, "\n");
}
# matches barbarbarfoo

print ("test 5 (lazy)\n");

$_ = "a xxx c xxxxx c xxx d";

if (/a(.*?)c.*?d/) {
    print ($&, "\n");
    print ("\"$1\"", "\n");
}
# first .*? matches " xxx " 
# (quotes only used to indicate spaces clearly)

print ("test 6 (degenerate match with *)\n");

$_= "!!!!!!!";

if (/\w*/) {
    print("Match found!\n");
    print ($&, "\n");
}
# matches "" since * is used 
# (0 or more occurrences)

