#!/usr/local/bin/perl -w

print("test 1 (foo to bar)\n");

$_ = "foot fool buffoon";
print($_, "\n");
s/foo/bar/;
print($_, "\n");
# $_ is now "bart fool buffon"
# changes first match encountered

print("test 2 (foo to bar, global)\n");

$_ = "foot fool buffoon";
print($_, "\n");
s/foo/bar/g;
print($_, "\n");
# $_ is now "bart barl bufbarn"
# changes all matches encountered (global)

print("test 3 (foo to bar, global, case insensitive)\n");

$_ = "foOt Fool buffOon";
print($_, "\n");
s/foo/bar/gi;
print($_, "\n");
# $_ is now "bart barl bufbarn"
# changes all matches encountered (global)
# case insensitive

print("test 4 (hello to goodbye, var. interp.)\n");

$_ = "hello world";
print($_, "\n");
$new = "goodbye";
s/hello/$new/; 
print($_, "\n");
# replaces hello with goodbye
