#!/usr/local/bin/perl -w


print("test 1 (no match)\n");

$_ = "baaad";

if (/a{4}/) {
  print("$&\n");
  print("$`\n");
  print("$'\n");
}
# nothing is printed; pattern
# doesn't match any portion 
# of the string


print("test 2 (matches 4)\n");

$_ = "baaaad";

if (/a{4}/) {
  print("$&\n");
  print("$`\n");
  print("$'\n");
}
# prints: 
# aaaa<newline>
# b<newline>
# d<newline>


print("test 3 (matches 4 of 5)\n");

$_ = "baaaaad";

if (/a{4}/) {
  print("$&\n");
  print("$`\n");
  print("$'\n");
}
# prints:
# aaaa<newline>
# b<newline>
# ad<newline>

print("test 5 (matches \"exactly\" 4 with *)\n");

$_ = "baaaaad";

if (/[^a]*a{4}[^a]*/) {
  print("$&\n");
  print("$`\n");
  print("$'\n");
}
# prints 
# baaaa<newline>
# <newline>
# ad<newline>

print("test 6 (only matches if exactly 4 - no match)\n");

$_ = "baaaaad";

if (/[^a]+a{4}[^a]+/) {
  print("$&\n");
  print("$`\n");
  print("$'\n");
}
# prints nothing


print("test 7 (matches exactly 4)\n");

$_ = "baaaad";

if (/[^a]+a{4}[^a]+/) {
  print("$&\n");
  print("$`\n");
  print("$'\n");
}
# prints: 
# baaaad<newline>
# <newline>
# <newline>


