#!/usr/local/bin/perl -w

print("test 1 (parens outside)\n");
$_ = "apples pears peaches plums";
/(\w*)\s+(\w*)\s+(\w*)/;
print ("$1\n$2\n$3\n");
# apples<newline>
# pears<newline>
# peaches<newline>

print("test 2 (parens outside)\n");
$_ = "apples pears peaches plums";
/(\w*)(\w*)(\w*)/;
print ("$1\n$2\n$3\n");
# apples<newline>
# <newline>
# <newline>

print("test 3 (any five)\n");
$_= "axxyxxb";
if (/a.{5}b/) {
  print("any five: $&\n");
}
# matches

print("test 4 (same five)\n");
if (/a(.)\1{4}b/) {
  print("same five: $&\n");
}
# doesn't match - due to 'y'

print("test 5 (HTML tags)\n");
$_ = "<B> bold text </B>";
if (/<([a-zA-Z0-9]*?)>.*?<\/\1>/) {
  print("bold: $&\n");
}
print("test 6 (HTML tags)\n");
$_ = "<i> italic text </i>";
if (/<([a-zA-Z0-9]*?)>.*?<\/\1>/) {
  print("italic: $&\n");
}
# same regex matches either string

print("test 7 (parens outside - first with no memory)\n");
$_ = "apples pears peaches plums";
/(?:\w*)\s+(\w*)\s+(\w*)/;
print ("$1\n$2\n$3\n");
# Use of uninitialized value at ././parens.plx line 47.
# pears<newline>
# peaches<newline>
# <newline>


